// Class code Set 15B
// newing arrays
// parallel arrays

final int MAX = 1000;

int [ ] xCoords;
int [ ] yCoords;
int [ ] zCoords;
int [ ] zDelta;
color [ ] cols;

void setup ()
{
  size( screen.width, screen.height, P3D );
  xCoords = new int[ MAX ];
  yCoords = new int[ MAX ];
  zCoords = new int[ MAX ];
  zDelta = new int[ MAX ];
  cols = new color[ MAX ];
  
  initCoords( xCoords, -10, width );
  initCoords( yCoords, -10, height );
  initCoords( zCoords, -10000, -5000 );
  initCoords( zDelta, 5, 15 );
  initColors( );
  
  strokeWeight( 2 );

}

void draw ( )
{
  background( 0 );
  //fill( 0 );
  //rect( 0, 0, width, height );
  movePoints( );
  plotPoints( );  
}

void initCoords( int [ ] coords, int  min, int max )
{
  for( int i = 0 ; i < coords.length ; i++ )
  {
    coords[i] = int( random( min, max ) );
  }
}

void initColors(   )
{
  for( int i = 0 ; i < cols.length ; i++ )
  {
    float r = random( 255 );
    float g = random( 255 );
    float b = random( 255 );
    cols[i] = color( r, g, b );
  }
}

void movePoints( )
{
  for( int i = 0 ; i < cols.length ; i++ )  
  {
    zCoords[i] += zDelta[i];
    if ( zCoords[i] >= 0 )
    {
       zCoords[i] = -10000; 
    }
  }  
}

void plotPoints ( )
{
  for( int i = 0 ; i < cols.length ; i++ )  
  {
    stroke( cols[i] );
    point( xCoords[i], yCoords[i], zCoords[i] );
  }
}
